package com.liang.controller;

import com.liang.common.annotation.LogAround;
import com.liang.entity.BaseEconomicsector;
import com.liang.service.BaseEconomicsectorService;
import io.swagger.annotations.ApiOperation;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * (BaseEconomicsector)表控制层
 *
 * @author makejava
 * @since 2023-03-04 11:45:27
 */
@Controller
@RequestMapping("baseEconomicsector")
public class BaseEconomicsectorController {
    /**
     * 服务对象
     */
    @Resource
    private BaseEconomicsectorService baseEconomicsectorService;

    /**
     * 分页查询
     *
     * @param baseEconomicsector 筛选条件
     * @param pageRequest        分页对象
     * @return 查询结果
     */
    @GetMapping
    public ResponseEntity<Page<BaseEconomicsector>> queryByPage(BaseEconomicsector baseEconomicsector, PageRequest pageRequest) {
        return ResponseEntity.ok(this.baseEconomicsectorService.queryByPage(baseEconomicsector, pageRequest));
    }

    /**
     * 通过主键查询单条数据
     *
     * @param id 主键
     * @return 单条数据
     */
    @GetMapping("{id}")
    public ResponseEntity<BaseEconomicsector> queryById(@PathVariable("id") String id) {
        return ResponseEntity.ok(this.baseEconomicsectorService.queryById(id));
    }

    /**
     * 新增数据
     *
     * @param baseEconomicsector 实体
     * @return 新增结果
     */
    @PostMapping
    public ResponseEntity<BaseEconomicsector> add(BaseEconomicsector baseEconomicsector) {
        return ResponseEntity.ok(this.baseEconomicsectorService.insert(baseEconomicsector));
    }

    /**
     * 编辑数据
     *
     * @param baseEconomicsector 实体
     * @return 编辑结果
     */
    @PutMapping
    public ResponseEntity<BaseEconomicsector> edit(BaseEconomicsector baseEconomicsector) {
        return ResponseEntity.ok(this.baseEconomicsectorService.update(baseEconomicsector));
    }

    /**
     * 删除数据
     *
     * @param id 主键
     * @return 删除是否成功
     */
    @DeleteMapping
    public ResponseEntity<Boolean> deleteById(String id) {
        return ResponseEntity.ok(this.baseEconomicsectorService.deleteById(id));
    }

    @ApiOperation(value = "页面初始化", notes = "页面初始化")
    @RequestMapping(value = "/init", method = RequestMethod.GET)
    public String init() {
        return "baseeconomicsector/list";
    }

    @LogAround("数据分页查询")
    @ApiOperation(value = "数据分页查询", notes = "数据分页查询")
    @ResponseBody
    @RequestMapping(value = "/list", method = RequestMethod.GET)
    public Object list() {

        List<BaseEconomicsector> list = baseEconomicsectorService.queryAll();

        Map<String, Object> resultMap = new HashMap<>();
        resultMap.put("code", 0);
        resultMap.put("msg", "");
        resultMap.put("count", list.size());
        resultMap.put("data", list);

        return resultMap;
    }
}

